package com.knauf.jsp.fileupload.tags;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.JspException;
import org.apache.commons.fileupload.*;

/**Tag fr das Parsen einer hochgeladenen Datei mittels Diskfileupload.
 * 
 */
public class DiskFileUploadLineOutputTag extends BodyTagSupport
{
	/**Der Request-Parameter, dessen Datei ausgewertet wird.
	 * Pflicht-Attribut */ 
	private String strRequestParameter = "";
	
	/**Liste der Zeilen, wird im doStartTag gefllt*/
	private ArrayList listLines = null;
	
	/**Iterator mit dem aktuellen Iterator-Status, wird im doStartTag gefllt */
	private Iterator iteratorLines = null;
	
	/**Index des aktuellen Elements, wird in PageContext geschrieben. */
	private int intIndexCurrent = 0;
	
	/**Tag ausfhren
	 * 
	 * @throws JspException
	 * @throws IOException
	 */
	public int doStartTag() throws JspException 
	{
		try
		{
			//Request verarbeiten:
			DiskFileUpload diskFileUpload = new DiskFileUpload ();
			List listFileItems = diskFileUpload.parseRequest( (HttpServletRequest) this.pageContext.getRequest() );
		
			//Item mit dem Namen "this.strRequestParameter" suchen:
			FileItem fileItemDatei = null;
			for (int intIndexItem = 0; intIndexItem < listFileItems.size(); intIndexItem++)
			{
				FileItem fileItemAktuell = (FileItem) listFileItems.get (intIndexItem);
				
				//Ist es ein Datei-Item oder ein sonstiges Formular-Element ?
				if (fileItemAktuell.isFormField() == false)
				{
					//Ist der Name "this.strRequestParameter" ?
					if (this.strRequestParameter.equals (fileItemAktuell.getFieldName() ) == true)
					{
						fileItemDatei = fileItemAktuell;
					}
				}
				else
				{
					//Sonstiges Formularfeld (Textfeld, Radiobutton, Checkbox, Auswahlliste). Ignorieren.
				}
			}
		
			//Haben wir etwas gefunden ?
			if (fileItemDatei == null)
			{
				throw new JspException ("Kein Attribut '" + this.strRequestParameter + "' im Request gefunden.");
			}
			
			//Datei zeilenweise in die ArrayList der Zeilen schreiben:
			BufferedReader bufferedReader = new java.io.BufferedReader ( new java.io.InputStreamReader (fileItemDatei.getInputStream( )) );
			String strLine = null;
			this.listLines = new ArrayList();
			while ( (strLine = bufferedReader.readLine() ) != null)
			{
				//this.pageContext.getOut().write ("Zeile: " + intZeile + ":" + strLine + "\n <br>");
				this.listLines.add (strLine);
			} 
			
			//Iterator initialisieren:
			this.iteratorLines = this.listLines.iterator();
		}
		catch (Exception ex)
		{
			throw new JspException ("Fehler beim Auswerten des Requests vom Typ '" + ex.getClass().getName() + "', Meldung: " + ex.getMessage(), ex);
		}
			
		System.out.println ("doStartTag: " + this.listLines.size());
		
		//Body auswerten, wenn Datei gltig ist !
		//Einmal im Iterator weiterlaufen, da wir sowieso die allererste Zeile
		//in den PageContext setzen mssen.
		if (this.iteratorLines.hasNext() == true)
		{
			String strLine = (String) this.iteratorLines.next();
			this.pageContext.setAttribute("line", strLine);
			//Und Zeilenzhler (den wir bei "0" lassen) setzen:
			this.pageContext.setAttribute("linenumber", new Integer (this.intIndexCurrent) );
			return TagSupport.EVAL_BODY_AGAIN;
		}
		else
		{
			//Nix da: wir mssen auch nichts tun.
			return TagSupport.SKIP_BODY;
		} 
	}
	
	
	public int doEndTag() throws JspException
	{
		System.out.println ("doEndTag");
		return super.doEndTag();
	}
	
	/*
	public void setBodyContent(BodyContent b)
	{
		System.out.println ("setBodyContent");
		super.setBodyContent(b);
	}*/
	public int doAfterBody() throws JspException
	{
		System.out.println ("doAfterBody");
		//return super.doAfterBody();
		
		if (bodyContent != null)
		{
			try
			{
				JspWriter out = getPreviousOut();
				String strBodyContent = this.bodyContent.getString();
				System.out.println ("bodyContent ausgeben: " + strBodyContent);
				out.print(strBodyContent);
				bodyContent.clearBody();
			}
			catch (IOException e)
			{
				System.out.println (e.toString());
			}
		}
		if (this.iteratorLines.hasNext())
		{
			//Zur nchsten Zeile weiterlaufen:
			String strLine = (String) this.iteratorLines.next();
			this.pageContext.setAttribute("line", strLine);
			//Zeilenzhler um 1 hochzhlen und in PageContext schreiben.
			++this.intIndexCurrent;
			this.pageContext.setAttribute("linenumber", new Integer (this.intIndexCurrent) );
			
			return (EVAL_BODY_AGAIN);
		}
		else
		{
			//Kein weiterer Body mehr:
			return (SKIP_BODY);
		}
	}
	
	/**Release: Aufrumen, d.h. nix mehr im PageContext stehen lassen.
	 * 
	 */
	public void release()
	{
		if (this.pageContext.getAttribute("line") != null)
			System.out.println ("remove Attribute 'line'");
		else
			System.out.println ("kein Attribute 'line' vorhanden");
		this.pageContext.removeAttribute("line");
		
		if (this.pageContext.getAttribute("linenumber") != null)
			System.out.println ("remove Attribute 'linenumber'");
		else
			System.out.println ("kein Attribute 'linenumber' vorhanden");
	
		this.pageContext.removeAttribute("linenumber");
		
		super.release();
	}
	
	/**Attribut "requestparameter" setzen (Pflichtfeld).
	 * @param str_RequestParameter
	 */
	public void setRequestparameter (String str_RequestParameter)
	{
		System.out.println ("setRequestParameter: " + str_RequestParameter);
		this.strRequestParameter = str_RequestParameter;
	}

}
